#pragma once


namespace GDIPlus3DText
{
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Drawing::Drawing2D;

	/// <summary> 
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class Form1 : public System::Windows::Forms::Form
	{	
	public:
		Form1(void)
		{
			InitializeComponent();
		}
  
	protected:
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
	private: System::Windows::Forms::Button *  btnArticleList;
	private: System::Windows::Forms::PictureBox *  picText;
	private: System::Windows::Forms::Button *  btnContactMe;
	private: System::Windows::Forms::Button *  btnClose;
	private: System::Windows::Forms::GroupBox *  groupBox1;


	private: System::Windows::Forms::NumericUpDown *  spnFontSize;


	private: System::Windows::Forms::TextBox *  txtToDisplay;
	private: System::Windows::Forms::Label *  label1;
	private: System::Windows::Forms::Label *  label2;
	private: System::Windows::Forms::Button *  btnDisplayText;

	private: System::Windows::Forms::Label *  label3;



	private: System::Windows::Forms::NumericUpDown *  spnDepth;

	private: System::Windows::Forms::Label *  label5;

	private: System::Windows::Forms::ComboBox *  cbxTextColour;
	private: System::Windows::Forms::ComboBox *  cbxShadowColour;
	private: System::Windows::Forms::Label *  label4;
	private: System::Windows::Forms::RadioButton *  rbtnEngraved;
	private: System::Windows::Forms::RadioButton *  rbtnShadow;
	private: System::Windows::Forms::RadioButton *  rbtnBlock;
	private: System::Windows::Forms::RadioButton *  rbtnEmboss;

	public:
		__value enum TextStyle
		{
			Shadow,
			Block,
			Emboss,
			Engrave
		};
		
	protected:
		String* textToDisplay;
		TextStyle style;
		Decimal fontSize;
		Decimal shadowDepth;
		Color textColour;
		Color shadowColour;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container * components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->btnArticleList = new System::Windows::Forms::Button();
			this->picText = new System::Windows::Forms::PictureBox();
			this->btnContactMe = new System::Windows::Forms::Button();
			this->btnClose = new System::Windows::Forms::Button();
			this->groupBox1 = new System::Windows::Forms::GroupBox();
			this->rbtnEngraved = new System::Windows::Forms::RadioButton();
			this->rbtnShadow = new System::Windows::Forms::RadioButton();
			this->rbtnBlock = new System::Windows::Forms::RadioButton();
			this->rbtnEmboss = new System::Windows::Forms::RadioButton();
			this->cbxShadowColour = new System::Windows::Forms::ComboBox();
			this->label4 = new System::Windows::Forms::Label();
			this->cbxTextColour = new System::Windows::Forms::ComboBox();
			this->spnFontSize = new System::Windows::Forms::NumericUpDown();
			this->txtToDisplay = new System::Windows::Forms::TextBox();
			this->label1 = new System::Windows::Forms::Label();
			this->label2 = new System::Windows::Forms::Label();
			this->spnDepth = new System::Windows::Forms::NumericUpDown();
			this->label3 = new System::Windows::Forms::Label();
			this->label5 = new System::Windows::Forms::Label();
			this->btnDisplayText = new System::Windows::Forms::Button();
			this->groupBox1->SuspendLayout();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->spnFontSize))->BeginInit();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->spnDepth))->BeginInit();
			this->SuspendLayout();
			// 
			// btnArticleList
			// 
			this->btnArticleList->Location = System::Drawing::Point(344, 72);
			this->btnArticleList->Name = S"btnArticleList";
			this->btnArticleList->Size = System::Drawing::Size(80, 23);
			this->btnArticleList->TabIndex = 3;
			this->btnArticleList->Text = S"Article &List";
			this->btnArticleList->Click += new System::EventHandler(this, btnArticleList_Click);
			// 
			// picText
			// 
			this->picText->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->picText->Location = System::Drawing::Point(8, 184);
			this->picText->Name = S"picText";
			this->picText->Size = System::Drawing::Size(320, 144);
			this->picText->TabIndex = 10;
			this->picText->TabStop = false;
			this->picText->Paint += new System::Windows::Forms::PaintEventHandler(this, picText_Paint);
			// 
			// btnContactMe
			// 
			this->btnContactMe->Location = System::Drawing::Point(344, 48);
			this->btnContactMe->Name = S"btnContactMe";
			this->btnContactMe->Size = System::Drawing::Size(80, 23);
			this->btnContactMe->TabIndex = 2;
			this->btnContactMe->Text = S"Contact &Me";
			this->btnContactMe->Click += new System::EventHandler(this, btnContactMe_Click);
			// 
			// btnClose
			// 
			this->btnClose->DialogResult = System::Windows::Forms::DialogResult::Cancel;
			this->btnClose->Location = System::Drawing::Point(344, 16);
			this->btnClose->Name = S"btnClose";
			this->btnClose->Size = System::Drawing::Size(80, 23);
			this->btnClose->TabIndex = 4;
			this->btnClose->Text = S"Cl&ose";
			this->btnClose->Click += new System::EventHandler(this, btnClose_Click);
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->rbtnEngraved);
			this->groupBox1->Controls->Add(this->rbtnShadow);
			this->groupBox1->Controls->Add(this->rbtnBlock);
			this->groupBox1->Controls->Add(this->rbtnEmboss);
			this->groupBox1->Controls->Add(this->cbxShadowColour);
			this->groupBox1->Controls->Add(this->label4);
			this->groupBox1->Controls->Add(this->cbxTextColour);
			this->groupBox1->Controls->Add(this->spnFontSize);
			this->groupBox1->Controls->Add(this->txtToDisplay);
			this->groupBox1->Controls->Add(this->label1);
			this->groupBox1->Controls->Add(this->label2);
			this->groupBox1->Controls->Add(this->spnDepth);
			this->groupBox1->Controls->Add(this->label3);
			this->groupBox1->Controls->Add(this->label5);
			this->groupBox1->Location = System::Drawing::Point(8, 8);
			this->groupBox1->Name = S"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(320, 168);
			this->groupBox1->TabIndex = 0;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = S"Display Settings";
			// 
			// rbtnEngraved
			// 
			this->rbtnEngraved->Location = System::Drawing::Point(232, 56);
			this->rbtnEngraved->Name = S"rbtnEngraved";
			this->rbtnEngraved->Size = System::Drawing::Size(72, 24);
			this->rbtnEngraved->TabIndex = 5;
			this->rbtnEngraved->Text = S"En&grave";
			this->rbtnEngraved->CheckedChanged += new System::EventHandler(this, rbtnEngraved_CheckedChanged);
			// 
			// rbtnShadow
			// 
			this->rbtnShadow->Checked = true;
			this->rbtnShadow->Location = System::Drawing::Point(16, 56);
			this->rbtnShadow->Name = S"rbtnShadow";
			this->rbtnShadow->Size = System::Drawing::Size(64, 24);
			this->rbtnShadow->TabIndex = 2;
			this->rbtnShadow->TabStop = true;
			this->rbtnShadow->Text = S"&Shadow";
			this->rbtnShadow->CheckedChanged += new System::EventHandler(this, rbtnShadow_CheckedChanged);
			// 
			// rbtnBlock
			// 
			this->rbtnBlock->Location = System::Drawing::Point(88, 56);
			this->rbtnBlock->Name = S"rbtnBlock";
			this->rbtnBlock->Size = System::Drawing::Size(64, 24);
			this->rbtnBlock->TabIndex = 3;
			this->rbtnBlock->Text = S"&Block";
			this->rbtnBlock->CheckedChanged += new System::EventHandler(this, rbtnBlock_CheckedChanged);
			// 
			// rbtnEmboss
			// 
			this->rbtnEmboss->Location = System::Drawing::Point(152, 56);
			this->rbtnEmboss->Name = S"rbtnEmboss";
			this->rbtnEmboss->Size = System::Drawing::Size(72, 24);
			this->rbtnEmboss->TabIndex = 4;
			this->rbtnEmboss->Text = S"&Emboss";
			this->rbtnEmboss->CheckedChanged += new System::EventHandler(this, rbtnEmboss_CheckedChanged);
			// 
			// cbxShadowColour
			// 
			this->cbxShadowColour->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbxShadowColour->Location = System::Drawing::Point(168, 136);
			this->cbxShadowColour->Name = S"cbxShadowColour";
			this->cbxShadowColour->Size = System::Drawing::Size(136, 21);
			this->cbxShadowColour->TabIndex = 13;
			// 
			// label4
			// 
			this->label4->Location = System::Drawing::Point(168, 120);
			this->label4->Name = S"label4";
			this->label4->Size = System::Drawing::Size(136, 16);
			this->label4->TabIndex = 12;
			this->label4->Text = S"Shadow colour:";
			this->label4->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
			// 
			// cbxTextColour
			// 
			this->cbxTextColour->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbxTextColour->Location = System::Drawing::Point(16, 136);
			this->cbxTextColour->Name = S"cbxTextColour";
			this->cbxTextColour->Size = System::Drawing::Size(128, 21);
			this->cbxTextColour->TabIndex = 11;
			// 
			// spnFontSize
			// 
			this->spnFontSize->Location = System::Drawing::Point(80, 88);
			this->spnFontSize->Name = S"spnFontSize";
			this->spnFontSize->Size = System::Drawing::Size(48, 20);
			this->spnFontSize->TabIndex = 7;
			System::Int32 __mcTemp__1[] = new System::Int32[4];
			__mcTemp__1[0] = 40;
			__mcTemp__1[1] = 0;
			__mcTemp__1[2] = 0;
			__mcTemp__1[3] = 0;
			this->spnFontSize->Value = System::Decimal(__mcTemp__1);
			// 
			// txtToDisplay
			// 
			this->txtToDisplay->Location = System::Drawing::Point(80, 24);
			this->txtToDisplay->Name = S"txtToDisplay";
			this->txtToDisplay->Size = System::Drawing::Size(224, 20);
			this->txtToDisplay->TabIndex = 1;
			this->txtToDisplay->Text = S"Tom Archer";
			// 
			// label1
			// 
			this->label1->Location = System::Drawing::Point(16, 24);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(56, 23);
			this->label1->TabIndex = 0;
			this->label1->Text = S"Te&xt:";
			this->label1->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			// 
			// label2
			// 
			this->label2->Location = System::Drawing::Point(16, 88);
			this->label2->Name = S"label2";
			this->label2->Size = System::Drawing::Size(56, 23);
			this->label2->TabIndex = 6;
			this->label2->Text = S"&Font Size:";
			this->label2->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			// 
			// spnDepth
			// 
			this->spnDepth->Location = System::Drawing::Point(256, 88);
			this->spnDepth->Name = S"spnDepth";
			this->spnDepth->Size = System::Drawing::Size(48, 20);
			this->spnDepth->TabIndex = 9;
			System::Int32 __mcTemp__2[] = new System::Int32[4];
			__mcTemp__2[0] = 5;
			__mcTemp__2[1] = 0;
			__mcTemp__2[2] = 0;
			__mcTemp__2[3] = 0;
			this->spnDepth->Value = System::Decimal(__mcTemp__2);
			// 
			// label3
			// 
			this->label3->Location = System::Drawing::Point(192, 88);
			this->label3->Name = S"label3";
			this->label3->Size = System::Drawing::Size(56, 23);
			this->label3->TabIndex = 8;
			this->label3->Text = S"&Depth:";
			this->label3->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			// 
			// label5
			// 
			this->label5->Location = System::Drawing::Point(16, 120);
			this->label5->Name = S"label5";
			this->label5->Size = System::Drawing::Size(128, 16);
			this->label5->TabIndex = 10;
			this->label5->Text = S"Text colour:";
			this->label5->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
			// 
			// btnDisplayText
			// 
			this->btnDisplayText->Location = System::Drawing::Point(344, 152);
			this->btnDisplayText->Name = S"btnDisplayText";
			this->btnDisplayText->Size = System::Drawing::Size(80, 23);
			this->btnDisplayText->TabIndex = 1;
			this->btnDisplayText->Text = S"Display &Text";
			this->btnDisplayText->Click += new System::EventHandler(this, btnDisplayText_Click);
			// 
			// Form1
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->CancelButton = this->btnClose;
			this->ClientSize = System::Drawing::Size(432, 333);
			this->Controls->Add(this->btnArticleList);
			this->Controls->Add(this->picText);
			this->Controls->Add(this->btnContactMe);
			this->Controls->Add(this->btnClose);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->btnDisplayText);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::Fixed3D;
			this->MaximizeBox = false;
			this->Name = S"Form1";
			this->Text = S"Managed Extensions - Using GDI+ to  Draw 3D Text";
			this->Load += new System::EventHandler(this, Form1_Load);
			this->groupBox1->ResumeLayout(false);
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->spnFontSize))->EndInit();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->spnDepth))->EndInit();
			this->ResumeLayout(false);

		}	
		private: System::Void Form1_Load(System::Object *  sender, System::EventArgs *  e)
		{
			for (int i = 1; i < 168; i++)
			{
				this->cbxShadowColour->Items->Add(__box(Color::FromKnownColor( (KnownColor)(i) )));
				this->cbxTextColour->Items->Add(__box(Color::FromKnownColor( (KnownColor)(i) )));
			}
			this->cbxShadowColour->SelectedIndex=34; // defaulting to black
			this->cbxTextColour->SelectedIndex=163;  // defaulting to white
		}

		private: System::Void btnClose_Click(System::Object *  sender, System::EventArgs *  e)
		{ this->Close(); }

		private: System::Void btnContactMe_Click(System::Object *  sender, System::EventArgs *  e)
		{
			System::Diagnostics::Process::Start(S"IExplore.exe", S"http://www.ArcherConsultingGroup.com/default.asp?id=1007");
		}

		private: System::Void btnArticleList_Click(System::Object *  sender, System::EventArgs *  e)
		{
			System::Diagnostics::Process::Start(S"IExplore.exe", S"http://www.codeguru.com/columns/DotNetTips");
		}

		private: System::Void btnDisplayText_Click(System::Object *  sender, System::EventArgs *  e)
		{
			// Set up internal display values
			textToDisplay = txtToDisplay->Text;
			
			if (rbtnShadow->Checked) style = TextStyle::Shadow;
			else if (rbtnBlock->Checked) style = TextStyle::Block;
			else if (rbtnEmboss->Checked) style = TextStyle::Emboss;
			else if (rbtnEngraved->Checked) style = TextStyle::Engrave;
			
			fontSize = spnFontSize->Value;
			shadowDepth = spnDepth->Value;

			textColour = Color::FromKnownColor( (KnownColor)(cbxTextColour->SelectedIndex+1));
			shadowColour = Color::FromKnownColor( (KnownColor)(cbxShadowColour->SelectedIndex+1));

			// Cause a repaint of the PictureBox
			picText->Invalidate();
		}

		private: System::Void rbtnShadow_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
		{
			// Just some defaults that I think look good on shadowed text
			this->cbxShadowColour->SelectedIndex=34;
			this->cbxTextColour->SelectedIndex=163;
			this->spnDepth->Text = S"5";

			this->cbxTextColour->Enabled = true;
			this->cbxShadowColour->Enabled = true;
		}

		private: System::Void rbtnBlock_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
		{
			// Just some defaults that I think look good on boxed text
			this->cbxShadowColour->SelectedIndex=34;
			this->cbxTextColour->SelectedIndex=163;
			this->spnDepth->Text = S"5";

			this->cbxTextColour->Enabled = true;
			this->cbxShadowColour->Enabled = true;
		}

		private: System::Void rbtnEmboss_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
		{
			// embossing is usually used when the text
			// colour is the same as the background colour
			// and the depth is 1
			int i = this->cbxTextColour->FindStringExact(S"Color [Control]");
			if (-1 != i)
				this->cbxTextColour->SelectedIndex = i;
			this->spnDepth->Text = S"1";

			this->cbxTextColour->Enabled = false;
			this->cbxShadowColour->Enabled = false;
		}

		private: System::Void rbtnEngraved_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
		{
			// engraving is usually used when the text
			// colour is the same as the background colour
			// and the depth is 1
			int i = this->cbxTextColour->FindStringExact(S"Color [Control]");
			if (-1 != i)
				this->cbxTextColour->SelectedIndex = i;
			this->spnDepth->Text = S"1";
			this->cbxTextColour->Enabled = false;
			this->cbxShadowColour->Enabled = false;
		}

		private: System::Void picText_Paint(System::Object *  sender, System::Windows::Forms::PaintEventArgs *  e)
		{
			if (textToDisplay)
			{
				// Obtain the Graphics object
				Graphics* g = e->Graphics;
	      
				// Instantiate the Font object based on the
				// user-supplied Font size
				System::Drawing::Font* font = 
					new System::Drawing::Font("Times New Roman", 
																		Convert::ToSingle(fontSize), 
																					 						FontStyle::Regular);

				// Obtain the size of the text to be rendered
				SizeF textSize = g->MeasureString(textToDisplay, font);

				// Create the text and shadow brushes
				SolidBrush* shadowBrush = new SolidBrush(shadowColour);
				SolidBrush* textBrush = new SolidBrush(textColour);

				// Clear the Picture Box control
				g->Clear(SystemColors::Control);

				// Text will be centered on Picture Box control
				Single x = (picText->Width - textSize.Width) / 2;
				Single y = (picText->Height - textSize.Height) / 2;

				// Draw the background text
				switch (style)
				{
					case TextStyle::Shadow:
						// Draw the underlying shadow first using 
						// user-supplied depth value
						g->DrawString(textToDisplay, 
													font, 
													shadowBrush,
													x + Convert::ToSingle(shadowDepth),
													y + Convert::ToSingle(shadowDepth));
					break;
					
					case TextStyle::Block:
						// Draw the background text first. Note that I'm drawing it once for 
						// every depth selected by the user. I also have the light source
						// coming from the upper-right for the simple reason that having it come
						// from the upper-left looks to much like shadow text. 
						for (int i = Convert::ToInt32(shadowDepth); i >= 0; i--)
						{
							g->DrawString(textToDisplay, 
														font, 
														shadowBrush,
														x - i, y + i);
						}
					break;
					
					case TextStyle::Emboss:
					case TextStyle::Engrave:
						g->DrawString(textToDisplay, 
													font, 
													shadowBrush,
													x + Convert::ToSingle( (style == TextStyle::Emboss ? shadowDepth : -shadowDepth) ),
													y + Convert::ToSingle( (style == TextStyle::Emboss ? shadowDepth : -shadowDepth) ) );
					break;
				}

				// Draw the foreground text
				g->DrawString(textToDisplay, font, textBrush, x, y);
			}
		}
	};
}
